// Stream.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include <Windows.h>
#include <fstream>
#include <vector>
#include <algorithm>
#include <iostream>
using  namespace std;


typedef std::vector<int> VECTOR_INT;     //Vector int for sorting data
struct FOR_THREAD                        //Structure that may transfer to thread any variables
{
	VECTOR_INT* vector;
	int flag;
};


DWORD WINAPI StreamFunction(void* input) //THREAD FUNCTION
{
	FOR_THREAD* structure = (FOR_THREAD*)input;	
	VECTOR_INT * VECTOR_INTuence = structure->vector;
	std::sort(VECTOR_INTuence->begin(), VECTOR_INTuence->end());
	return 0;
}

VECTOR_INT getSequence();                             //Read data from file
VECTOR_INT * getHalfVector(VECTOR_INT sourceVector);  //Devide input array into 2 vectors
VECTOR_INT Merge(VECTOR_INT * halfs);                 //Merge Data into single vector
void printVECTOR_INT(VECTOR_INT VECTOR_INTuence);     //Write output

void main()
{
	VECTOR_INT * halfSequences = getHalfVector(getSequence());    //Make pointer for two vectors each one of them contains half of input array
	FOR_THREAD ft_vectorsA,ft_vectorsB;                           //Declare data structures
	ft_vectorsA.vector = &halfSequences[0];                       //Load data to vector, first and last half of the input array
	ft_vectorsB.vector = &halfSequences[1]; 
	                                                              //CreateThread and translate structure to it's input
	HANDLE thread1 = CreateThread(NULL, 0, StreamFunction, (void*)&ft_vectorsA, 0, NULL);  
	HANDLE thread2 = CreateThread(NULL, 0, StreamFunction, (void*)&ft_vectorsB, 0, NULL); 

	WaitForSingleObject(thread1, INFINITE);     //Initialize Threads and wait until it's acomplished
	WaitForSingleObject(thread2, INFINITE);

	halfSequences[0] = *ft_vectorsA.vector;     //Transfer Data back from structures back for merge 
	halfSequences[1] = *ft_vectorsB.vector;

	printVECTOR_INT(Merge(halfSequences));      
	CloseHandle(thread1);
	CloseHandle(thread2);
}

VECTOR_INT getSequence()
{
	std::ifstream in("input.txt");
	VECTOR_INT result(0);
	if (in.is_open())
	{
		while (!in.eof())
		{
			int numb;
			in >> numb;
			result.push_back(numb);
		}
		in.close();
	}
	in.close();

	return result;
}

VECTOR_INT Merge(VECTOR_INT * halfs)
{
	VECTOR_INT result;
	UINT i = 0;
	UINT j = 0;

	while(i <  halfs[0].size() && j < halfs[1].size())
	{
		if(halfs[0][i] <= halfs[1][j])
		{	
			result.push_back(halfs[0][i]);
			i++;
		}
		else
		{	
			result.push_back(halfs[1][j]);
			j++;
		}
	}
	while(i <  halfs[0].size())
	{	
		result.push_back(halfs[0][i]);
		i++;
	}
	while(j <  halfs[1].size())
	{	
		result.push_back(halfs[1][j]);
		j++;
	}

	return result;
}

VECTOR_INT * getHalfVector(VECTOR_INT sourceVector)
{
	VECTOR_INT * halfSequences = new VECTOR_INT[2];
	int curHalf = 0;
	for(UINT i=0;i<sourceVector.size();i++)
	{	
		if(i >= sourceVector.size() / 2)
			curHalf = 1;
		halfSequences[curHalf].push_back(sourceVector[i]);
	}
	return halfSequences;
}

void printVECTOR_INT(VECTOR_INT VECTOR_INTuence)
{
	std::ofstream out("output.txt");
	if (out.is_open() == false)
	{	
		out.close();
		return;
	}

	for(UINT i = 0;i<VECTOR_INTuence.size();i++)
		out << VECTOR_INTuence[i]<<" ";
	out.close();
}